using System;
using System.CodeDom.Compiler;
using System.ComponentModel;
using System.Diagnostics;
using System.Threading;
using System.Web.Services;
using System.Web.Services.Description;
using System.Web.Services.Protocols;

namespace Microsoft.SmallBasic.Library.Internal
{
	/// <remarks />
	[GeneratedCode("wsdl", "3.5.20706.1")]
	[DebuggerStepThrough]
	[DesignerCategory("code")]
	[WebServiceBinding(Name = "ResearchSoap", Namespace = "urn:Microsoft.Search")]
	public class OfficeResearch : SoapHttpClientProtocol
	{
		private SendOrPostCallback QueryOperationCompleted;

		private SendOrPostCallback RegistrationOperationCompleted;

		private SendOrPostCallback StatusOperationCompleted;

		private SendOrPostCallback DiscoveryOperationCompleted;

		/// <remarks />
		public event QueryCompletedEventHandler QueryCompleted;

		/// <remarks />
		public event RegistrationCompletedEventHandler RegistrationCompleted;

		/// <remarks />
		public event StatusCompletedEventHandler StatusCompleted;

		/// <remarks />
		public event DiscoveryCompletedEventHandler DiscoveryCompleted;

		/// <remarks />
		public OfficeResearch()
		{
			base.Url = "http://rr.office.microsoft.com/Research/query.asmx";
		}

		/// <remarks />
		[SoapDocumentMethod("urn:Microsoft.Search/Query", RequestNamespace = "urn:Microsoft.Search", ResponseNamespace = "urn:Microsoft.Search", Use = SoapBindingUse.Literal, ParameterStyle = SoapParameterStyle.Wrapped)]
		public string Query(string queryXml)
		{
			object[] array = Invoke("Query", new object[1]
			{
				queryXml
			});
			return (string)array[0];
		}

		/// <remarks />
		public IAsyncResult BeginQuery(string queryXml, AsyncCallback callback, object asyncState)
		{
			return BeginInvoke("Query", new object[1]
			{
				queryXml
			}, callback, asyncState);
		}

		/// <remarks />
		public string EndQuery(IAsyncResult asyncResult)
		{
			object[] array = EndInvoke(asyncResult);
			return (string)array[0];
		}

		/// <remarks />
		public void QueryAsync(string queryXml)
		{
			QueryAsync(queryXml, null);
		}

		/// <remarks />
		public void QueryAsync(string queryXml, object userState)
		{
			if (QueryOperationCompleted == null)
			{
				QueryOperationCompleted = OnQueryOperationCompleted;
			}
			InvokeAsync("Query", new object[1]
			{
				queryXml
			}, QueryOperationCompleted, userState);
		}

		private void OnQueryOperationCompleted(object arg)
		{
			if (this.QueryCompleted != null)
			{
				InvokeCompletedEventArgs invokeCompletedEventArgs = (InvokeCompletedEventArgs)arg;
				this.QueryCompleted(this, new QueryCompletedEventArgs(invokeCompletedEventArgs.Results, invokeCompletedEventArgs.Error, invokeCompletedEventArgs.Cancelled, invokeCompletedEventArgs.UserState));
			}
		}

		/// <remarks />
		[SoapDocumentMethod("urn:Microsoft.Search/Registration", RequestNamespace = "urn:Microsoft.Search", ResponseNamespace = "urn:Microsoft.Search", Use = SoapBindingUse.Literal, ParameterStyle = SoapParameterStyle.Wrapped)]
		public string Registration(string registrationXml)
		{
			object[] array = Invoke("Registration", new object[1]
			{
				registrationXml
			});
			return (string)array[0];
		}

		/// <remarks />
		public IAsyncResult BeginRegistration(string registrationXml, AsyncCallback callback, object asyncState)
		{
			return BeginInvoke("Registration", new object[1]
			{
				registrationXml
			}, callback, asyncState);
		}

		/// <remarks />
		public string EndRegistration(IAsyncResult asyncResult)
		{
			object[] array = EndInvoke(asyncResult);
			return (string)array[0];
		}

		/// <remarks />
		public void RegistrationAsync(string registrationXml)
		{
			RegistrationAsync(registrationXml, null);
		}

		/// <remarks />
		public void RegistrationAsync(string registrationXml, object userState)
		{
			if (RegistrationOperationCompleted == null)
			{
				RegistrationOperationCompleted = OnRegistrationOperationCompleted;
			}
			InvokeAsync("Registration", new object[1]
			{
				registrationXml
			}, RegistrationOperationCompleted, userState);
		}

		private void OnRegistrationOperationCompleted(object arg)
		{
			if (this.RegistrationCompleted != null)
			{
				InvokeCompletedEventArgs invokeCompletedEventArgs = (InvokeCompletedEventArgs)arg;
				this.RegistrationCompleted(this, new RegistrationCompletedEventArgs(invokeCompletedEventArgs.Results, invokeCompletedEventArgs.Error, invokeCompletedEventArgs.Cancelled, invokeCompletedEventArgs.UserState));
			}
		}

		/// <remarks />
		[SoapDocumentMethod("urn:Microsoft.Search/Status", RequestNamespace = "urn:Microsoft.Search", ResponseNamespace = "urn:Microsoft.Search", Use = SoapBindingUse.Literal, ParameterStyle = SoapParameterStyle.Wrapped)]
		public string Status()
		{
			object[] array = Invoke("Status", new object[0]);
			return (string)array[0];
		}

		/// <remarks />
		public IAsyncResult BeginStatus(AsyncCallback callback, object asyncState)
		{
			return BeginInvoke("Status", new object[0], callback, asyncState);
		}

		/// <remarks />
		public string EndStatus(IAsyncResult asyncResult)
		{
			object[] array = EndInvoke(asyncResult);
			return (string)array[0];
		}

		/// <remarks />
		public void StatusAsync()
		{
			StatusAsync(null);
		}

		/// <remarks />
		public void StatusAsync(object userState)
		{
			if (StatusOperationCompleted == null)
			{
				StatusOperationCompleted = OnStatusOperationCompleted;
			}
			InvokeAsync("Status", new object[0], StatusOperationCompleted, userState);
		}

		private void OnStatusOperationCompleted(object arg)
		{
			if (this.StatusCompleted != null)
			{
				InvokeCompletedEventArgs invokeCompletedEventArgs = (InvokeCompletedEventArgs)arg;
				this.StatusCompleted(this, new StatusCompletedEventArgs(invokeCompletedEventArgs.Results, invokeCompletedEventArgs.Error, invokeCompletedEventArgs.Cancelled, invokeCompletedEventArgs.UserState));
			}
		}

		/// <remarks />
		[SoapDocumentMethod("urn:Microsoft.Search/Discovery", RequestNamespace = "urn:Microsoft.Search", ResponseNamespace = "urn:Microsoft.Search", Use = SoapBindingUse.Literal, ParameterStyle = SoapParameterStyle.Wrapped)]
		public string Discovery(string registrationXml)
		{
			object[] array = Invoke("Discovery", new object[1]
			{
				registrationXml
			});
			return (string)array[0];
		}

		/// <remarks />
		public IAsyncResult BeginDiscovery(string registrationXml, AsyncCallback callback, object asyncState)
		{
			return BeginInvoke("Discovery", new object[1]
			{
				registrationXml
			}, callback, asyncState);
		}

		/// <remarks />
		public string EndDiscovery(IAsyncResult asyncResult)
		{
			object[] array = EndInvoke(asyncResult);
			return (string)array[0];
		}

		/// <remarks />
		public void DiscoveryAsync(string registrationXml)
		{
			DiscoveryAsync(registrationXml, null);
		}

		/// <remarks />
		public void DiscoveryAsync(string registrationXml, object userState)
		{
			if (DiscoveryOperationCompleted == null)
			{
				DiscoveryOperationCompleted = OnDiscoveryOperationCompleted;
			}
			InvokeAsync("Discovery", new object[1]
			{
				registrationXml
			}, DiscoveryOperationCompleted, userState);
		}

		private void OnDiscoveryOperationCompleted(object arg)
		{
			if (this.DiscoveryCompleted != null)
			{
				InvokeCompletedEventArgs invokeCompletedEventArgs = (InvokeCompletedEventArgs)arg;
				this.DiscoveryCompleted(this, new DiscoveryCompletedEventArgs(invokeCompletedEventArgs.Results, invokeCompletedEventArgs.Error, invokeCompletedEventArgs.Cancelled, invokeCompletedEventArgs.UserState));
			}
		}

		/// <remarks />
		public new void CancelAsync(object userState)
		{
			base.CancelAsync(userState);
		}
	}
}
